import yt

ds = yt.load("BonnorEbert_hdf5_plt_cnt_0010")

#Define region:
parsec = 3.08567758e18
width  = 1.0
centro = [0.0*parsec, 0.0*parsec, 0.0*parsec]
depth  = [width*parsec, width*parsec, width*parsec]

centro[0] = ds.quan(centro[0],'code_length')
centro[1] = ds.quan(centro[1],'code_length')
centro[2] = ds.quan(centro[2],'code_length')
left_corner[0]  = centro[0] - 0.5 * ds.quan(depth[0],'code_length')
right_corner[0] = centro[0] + 0.5 * ds.quan(depth[0],'code_length')
left_corner[1]  = centro[1] - 0.5 * ds.quan(depth[1],'code_length')
right_corner[1] = centro[1] + 0.5 * ds.quan(depth[1],'code_length')
left_corner[2]  = centro[2] - 0.5 * ds.quan(depth[2],'code_length')
right_corner[2] = centro[2] + 0.5 * ds.quan(depth[2],'code_length')

region = ds.region(centro, left_corner, right_corner)

# Some statistics:
ad = ds.all_data()

min_velx, max_velx = region.quantities.extrema("velx")
min_vely, max_vely = region.quantities.extrema("vely")
min_velz, max_velz = region.quantities.extrema("velz")

print('Velocidad de bulto', ad.quantities.bulk_velocity())
print('Max/min velx = ', max_velx, min_velx)
print('Max/min vely = ', max_vely, min_vely)
print('Max/min velz = ', max_velz, min_velz)

#slc = yt.SlicePlot(ds,'z','dens',center='c')
#slc.save()
