import yt

ds = yt.load("BonnorEbert_hdf5_plt_cnt_0010")

slc = yt.SlicePlot(ds,'z','dens',center='c')

#https://yt-project.org/doc/reference/api/yt.visualization.plot_modifications.html#yt.visualization.plot_modifications.TextLabelCallback
time = ds.current_time.in_units("Myr")
p.annotate_text((0.7, 0.95), '$t_{grav}=$'+str("{:4.2f}".format(time)) + ' Myr',
          coord_system='axis', text_args={'size':'xx-large', 'color':'w'},
          inset_box_args={'boxstyle':'square,pad=0.3',
             'facecolor':'black',
             'linewidth':3,
             'edgecolor':'white',
             'alpha':0.5})

slc.save()
