import yt

# Import yt units:
from yt.units import *

ds = yt.load("BonnorEbert_hdf5_plt_cnt_0010")

# Define the number density field:
def _cdens(field, data):
  return (1.0/mu_mol/1.67e-24/gram)*data['dens']
yt.add_field(name=("Number_density"), function=_cdens, sampling_type="local", units="cm**-3",)

#slc = yt.SlicePlot(ds,'z','dens',center='c')
slc = yt.SlicePlot(ds,'z','Number_density',center='c')

slc.save()
