import yt
import matplotlib.pyplot as plt

ds = yt.load("BonnorEbert_hdf5_plt_cnt_0010")

# Get a sphere object

sp = ds.sphere(ds.domain_center, (40., "pc"))

# Bin up the data from the sphere into a radial profile

rp = yt.create_profile(sp, 'radius', 'density',
                       units = {'radius': 'pc'},
                       logs = {'radius': False})

# Make plots using matplotlib

plt.semilogy(rp.x.value, rp["density"].value)

# Plot the density as a log-log plot using the default settings
#plt.loglog(rp.x.value, rp["density"].value)

# Here we set the labels of the plot axes

plt.xlabel(r"$\mathrm{r\ (kpc)}$")
plt.ylabel(r"$\mathrm{\rho\ (g\ cm^{-3})}$")
#plt.xlim(0,45)
#plt.ylim(0.01,1e8)

# Save the default plot
plt.savefig("density_profile_default.png" % ds)
