import yt
import matplotlib.pyplot as plt

ds = yt.load("SpitzerTest_hdf5_plt_cnt_0010")

# Get and print simulation time
time = ds.current_time.in_units('Myr')
print(ds.current_time, ' = ', time)

# Get a sphere object
sp = ds.sphere(ds.domain_center, (14.5, "pc"))

# Bin up the data from the sphere into a radial profile
rp = yt.create_profile(sp, 'radius', 'density',
                       units = {'radius': 'pc'},
                       logs = {'radius': False})

# Make plots using matplotlib
plt.semilogy(rp.x.value, rp["density"].value)
plt.xlabel(r"$\mathrm{r\ (kpc)}$")
plt.ylabel(r"$\mathrm{\rho\ (g\ cm^{-3})}$")

plt.xlabel(r"$\mathrm{r\ (pc)}$")
plt.ylabel(r"$\mathrm{\rho\ (g\ cm^{-3})}$")
#plt.xlim(0,45)
#plt.ylim(0.01,1e8)

# Save the default plot
plt.savefig("density_profile_default.png" % ds)
