import yt
import numpy as np
import h5py
from yt.units import *
from yt.units.yt_array import YTArray
import matplotlib.pyplot as plt
from mpl_toolkits.axes_grid1 import AxesGrid
#from astropy.io import fits
#import matplotlib
#import matplotlib.pyplot as plt


tini = 0
tend = 100
inc  = 1

#direction = 'x'
direction = 'y'
#direction = 'z' # x & z

base_name = 'proj'
#basename  = '/fs/mouruka/Part1/maza/sn_flows/flows_hdf5_plt_cnt_0'
#basename  = '/fs/calzonzin/Part3/maza/SN/sn_flows_n3/flows_hdf5_plt_cnt_0'
#basename  = '/fs/nas10/other0/maza/cfs/r10f1B3mG/flows_hdf5_plt_cnt_0'
#basename  ='/fs/mouruka/Part1/maza/Turb2/M10_l7/'
#basename  = '/fs/nas17/other1/maza/Turb2/M10_l7_restart_Miztli/flows_hdf5_chk_0'
#basename  = '/fs/nas17/other1/maza/Turb2/M10_l7_restart_Miztli/flows_hdf5_plt_cnt_0'
basename  = '/fs/mouruka/Part1/maza/Fer/t2-y-rot-1e4/flows_hdf5_plt_cnt_0'
#basename  = '/fs/mouruka/Part1/maza/Turb/StitTurb_default/Turb_hdf5_plt_cnt_0'

n_sink = 100

#colormap = 'BLUE'
colormap = 'RED TEMPERATURE'


width = 1.   # with of the projection (for subregion == 0)
parsec = 3.08567758e18

centro =  [127.*parsec,(70.9-3.0)*parsec,(55.+1.)*parsec] # in pc --> center of the subregion box 
depth   = [width*parsec, width*parsec, width*parsec] # in pc --> size of the subregion

plot_dir  = '' # path of the plot directory

#width1d = width # depth of the projection in pc
if direction == 'z':
 id_dir = '_xy'
 width1d = depth[2]/parsec
elif direction == 'x':
 id_dir = '_yz'
 width1d = depth[0]/parsec
else: #direction = 'y'
 id_dir = '_zx'
 width1d = depth[1]/parsec

Ns = 0
Ms = 0.
left_corner  = [0.0,0.0,0.0]
right_corner = [0.0,0.0,0.0]

for i in range(tini, tend+1, inc):
# fn = basename + 'flows_hdf5_plt_cnt_0' + str(i).zfill(3)
# fnp= basename + 'flows_hdf5_part_0' + str(i).zfill(3)
 fn = basename + str(i).zfill(3)
 fnp= basename + str(i).zfill(3)


 print('============================================================================')
 print(fn)


 fig = plt.figure()

# See http://matplotlib.org/mpl_toolkits/axes_grid/api/axes_grid_api.html
# These choices of keyword arguments produce a four panel plot with a single
# shared narrow colorbar on the right hand side of the multipanel plot. Axes
# labels are drawn for all plots since we're slicing along different directions
# for each plot.
 grid = AxesGrid(fig, (0.075,0.075,0.85,0.85),
                nrows_ncols = (1, 1),
                axes_pad = 0.05,
                label_mode = "L",
                share_all = True,
                cbar_location="right",
                cbar_mode="single",
 				cbar_size="3%",
                cbar_pad="0.6%")

# Load the data and create a single plot
 ds = yt.load(fn) #, particle_filename=fnp) # load data



#dd = ds.all_data()
#print dd["particle_position_x"]
#
#or the velocities:
#
#print dd["particle_velocity_x"]


# if i >= n_sink:
#  f = h5py.File(fn,"r")
#  ParticleData = f['particle tracers']
#  ppz = ParticleData["particle_z"]
#  ppy = ParticleData["particle_y"]
#  ppx = ParticleData["particle_x"]
#  ppm = ParticleData["particle_mass"]
#  ppt = ParticleData["particle_tag"]
#  data = {'particle_position_x': ppx,
#	    'particle_position_y': ppy,
#	    'particle_position_z': ppz,
#	    'particle_mass': ppm,
#        'particle_tag': ppt}
#  f.close()
#  del ParticleData
#  del f
#
##  ind = np.argmax(ppm)
##  print 'Star masses :: ', ppm/2.e33
##  print 'maximum x :: ', ppx, ind
##  print 'maximum y :: ', ppy, ind
##  print 'maximum x :: ', ppz, ind
## print ppm
## print ppx
#
#  massive_sinks = (ppm > 100.0*1.989e33)
#  ppzm = ppz[massive_sinks]
#  ppym = ppy[massive_sinks]
#  ppxm = ppx[massive_sinks]
#  Ms = sum(ppm)/2.e33
#  Ns = ppm.__len__()


 def _cdens(field, data):
    return (1.0/1.27/1.67e-24/gram)*data['dens']
 ds.add_field("Number_density", units="cm**-3", function=_cdens)


# http://yt-project.org/doc/analyzing/filtering.html
# ad = ds.all_data()
# dense_ad = ad.cut_region(['(obj["Number_density"] > 5e5)']) # & (obj["velz"].in_units("km/s") > 1)'])

# if subregion == 0:
#  print 'Ploting all the box...'
#  p = yt.ProjectionPlot(ds, direction, 'Number_density', width=(width, 'pc'), center='c')
# else:
#  print 'Ploting a subregion...'

## Center on the domain center
#  center = ds.domain_center
## First make the left and right corner of the region based on the full domain.
#  left_corner = ds.domain_left_edge
#  right_corner = ds.domain_right_edge

## Now adjust the size of the region along the line of sight (z axis).
 centro[0] = ds.quan(centro[0],'code_length')
 centro[1] = ds.quan(centro[1],'code_length')
 centro[2] = ds.quan(centro[2],'code_length')
 left_corner[0]  = centro[0] - 0.5 * ds.quan(depth[0],'code_length')
 right_corner[0] = centro[0] + 0.5 * ds.quan(depth[0],'code_length')
 left_corner[1]  = centro[1] - 0.5 * ds.quan(depth[1],'code_length')
 right_corner[1] = centro[1] + 0.5 * ds.quan(depth[1],'code_length')
 left_corner[2]  = centro[2] - 0.5 * ds.quan(depth[2],'code_length')
 right_corner[2] = centro[2] + 0.5 * ds.quan(depth[2],'code_length')
  
 region = ds.region(centro, left_corner, right_corner)

 p = yt.ProjectionPlot(ds, direction, 'Number_density', data_source=region)
# p = yt.ProjectionPlot(ds, direction, 'Number_density')
 
# p.annotate_particles((1.0, 'pc'))

 p.annotate_timestamp(corner='upper_left', draw_inset_box=True)
 p.annotate_velocity(factor=64)
## p.annotate_quiver('velz', 'velx', factor=120) #, scale=0.5, scale_units="inches", normalize = True) #,  bv_x = 0.5, bv_y = 0.5)
## p.annotate_quiver('magz', 'magx', factor=120) #, scale=0.5, scale_units="inches", normalize = True) #,  bv_x = 0.5, bv_y = 0.5)
## p.annotate_velocity(factor=90)
# ad = ds.all_data()
# min_velx, max_velx = region.quantities.extrema("velx")
# min_vely, max_vely = region.quantities.extrema("vely")
# min_velz, max_velz = region.quantities.extrema("velz")
# 
# print 'Velocidad de bulto', ad.quantities.bulk_velocity()
# print 'Max/min velx = ', max_velx, min_velx
# print 'Max/min vely = ', max_vely, min_vely
# print 'Max/min velz = ', max_velz, min_velz
  
# p.annotate_text((0.8, 0.95), 'FLASH',
#		 text_args={'size':'xx-large', 'color':'w'})
# p.annotate_text((0.05, 0.95), '$r_{\mathrm{acc}}=\Delta x$; $n_{\mathrm{thr}}=10^6 ~\mathrm{cm}^{-3}$ ' + 'N$_{\mathrm{sinks}}=$'+str(Ns),
#		                         text_args={'size':'xx-large', 'color':'w'})


## p.annotate_text((0.6, 0.95), s_profile + ' / ' + s_res, coord_system='axis',
##		 text_args={'size':'xx-large', 'color':'w'})
# p.annotate_text((0.6, 0.95), s_mach, 
#		 coord_system='axis', text_args={'size':'xx-large', 'color':'w'}) #'k'-->black
# #p.annotate_text((0.6, 0.85), s_shear, 
##		 coord_system='axis', text_args={'size':'xx-large', 'color':'w'}) #'k'-->black
#
## p.annotate_text((0.55, 0.95), 'HD / Mach = 16', coord_system='axis',
##		                        text_args={'size':'xx-large', 'color':'w'}) #'k'-->black
## p.annotate_text((0.55, 0.9), s_res +  ' / ' + s_shear, 
##		 coord_system='axis', text_args={'size':'xx-large', 'color':'w'}) #'k'-->black
## p.annotate_text((0.55, 0.85), s_profile, coord_system='axis',
##		 text_args={'size':'xx-large', 'color':'w'})
## p.annotate_text((0.55, 0.80), s_mag, coord_system='axis',
##		 text_args={'size':'xx-large', 'color':'w'})
#
# # p.annotate_text((0.7, 0.90), '$B_{\mathrm{max}}=5.9 \, \mathrm{mG}$',
##                text_args={'size':'xx-large', 'color':'k'})
## tff = ds.quan(2.7,'Myr')
#
# time = ds.current_time.in_units('Myr')
# timetff = np.power(10, np.log10(time))/2.7
# timeMyr = np.power(10, np.log10(time))
# Mass = str('{:.2e}'.format(float(Ms))) #'{:.2e}'.format(str(Ms))  #"{:.2E}".format(Decimal(str(Ms)))  #'%.2E' % Decimal(str(Ms))
# SFE = Ms/1.e4 #%
# print Mass, '{:.2e}'.format(float(Ms))
## p.annotate_text((0.05, 0.95), '$t/t_{ff}=$'+str("{:4.2f}".format(timetff)) + ' (' +
##		 str("{:4.2f}".format(timeMyr)) + ' Myr)', coord_system='axis', 
##		 text_args={'size':'xx-large', 'color':'w'}) 
## p.annotate_text((0.05, 0.9), 'N$_{\mathrm{sinks}}=$'+str(Ns), coord_system='axis',text_args={'size':'xx-large', 'color':'w'})
## p.annotate_text((0.05, 0.85), 'M$_{\mathrm{sinks}}=$'+ Mass +' M$_{\odot}$', coord_system='axis', text_args={'size':'xx-large', 'color':'w'})
## p.annotate_text((0.05, 0.8), 'SFE ='+ str("{:4.1f}".format(SFE)) +'%', coord_system='axis', text_args={'size':'xx-large', 'color':'w'})
#
## p.annotate_text((0.7, 0.95), 'Edge-on view',
##		                         text_args={'size':'xx-large', 'color':'w'})
 

############################# 
# for ii in range(0,Ns):
#         p.annotate_marker((ppx[ii],ppy[ii],ppz[ii]), marker='o', plot_args={'color': 'white','s':10})
#         if (ppt[ii] != 65678):
#          p.annotate_text((ppx[ii],ppy[ii],ppz[ii]),
#                 str(ppt[ii]),text_args={'size':'xx-large','color':'w'},
#                 inset_box_args={'facecolor':'none',
#                 'edgecolor':'none','pad':10})
#         else:
#          p.annotate_text((ppx[ii],ppy[ii],ppz[ii]-1.5*parsec),
#                 str(ppt[ii]),text_args={'size':'xx-large','color':'w'},
#                 inset_box_args={'facecolor':'none',
#                 'edgecolor':'none','pad':10})
# 

#  p.annotate_marker([1.49364392e+18,1.69062844e+18,1.24930528e+18], marker='o',plot_args={'color':'white','s':20})
#  p.annotate_marker([1.49364392e+18,1.69062844e+18,1.24930528e+18], marker='o',plot_args={'color':'black','s':10})
  
# p.set_cmap(field="Number_density", cmap=colormap)
## p.annotate_timestamp(-0.24, -0.24, 'kyr')#,"{time:2.1G}") #(-9, -9)
 p.set_zlim('Number_density', 1e19, 1e23) # Ensure the colorbar limits match for all plots
 p.set_colorbar_label('Number_density','Column Density (cm$^{-2})$')

 p.set_cmap(field="Number_density", cmap=colormap)
# p.annotate_timestamp(-0.24, -0.24, 'kyr')#,"{time:2.1G}") #(-9, -9)
# p.set_zlim('dens', 1e-1, 1e2) # Ensure the colorbar limits match for all plots
# p.set_colorbar_label('dens','Column density (cm$^{-2})$')

# if a_vel:
# p.annotate_streamlines('magx', 'magy')
# p.annotate_magnetic_field(factor=90)#128)
# p.annotate_velocity(factor = 90)
# Para la direccion 'z', plano(x,y)
# x = np.array([-10, 10, 10, -10, -10])
# y = np.array([4,    4,-16, -16,  4])
# p.annotate_line(x, y, plot_args={'linewidth':1, 'color':'white'})

 p.set_buff_size(3200)

# This forces the ProjectionPlot to redraw itself on the AxesGrid axes.
# plot = p.plots[('flash','Number_density')]
 plot = p.plots['Number_density']
# plot = p.plots['dens']
 plot.figure = fig
 plot.axes = grid[0].axes
 plot.cax = grid.cbar_axes[0]

# Finally, this actually redraws the plot.
 p._setup_plots()
# plt.savefig(plot_file + 'A_' + base_name + '_TreeSol_xy-t' + str(i).zfill(3) + '.png')
 plt.savefig(plot_dir + base_name + id_dir + '-t' + str(i).zfill(3) + '.png')
# plt.savefig(plot_dir + base_name + id_dir + '-t' + str(i).zfill(3) + '.eps')
# plt.savefig('mg_Tree_l8/' + base_name + '_TreeSol_xy-t' + str(i).zfill(3) + '.png')
 print("")
 print('Wrote: ' + plot_dir + base_name + id_dir + '-t' + str(i).zfill(3) + '.png')
 print("")
